? opaque-var-2.patch
? opaque-var.patch
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.82
diff -u -p -r1.82 ChangeLog
--- src/data/ChangeLog	10 Dec 2006 02:33:43 -0000	1.82
+++ src/data/ChangeLog	10 Dec 2006 03:30:13 -0000
@@ -1,3 +1,165 @@
+Sat Dec  9 18:05:59 2006  Ben Pfaff  <blp@gnu.org>
+
+	* data-out.c (output_scientific): Fix bad assumption that "buf" is
+	null-terminated.
+	
+Sat Dec  9 17:23:23 2006  Ben Pfaff  <blp@gnu.org>
+
+	Finish converting struct variable to an opaque type.  In this
+	phase, we add remaining setter and getter functions, convert the
+	remaining PSPP code to use them, and do a bunch of cleanup.  The
+	resulting changes are pervasive but mostly trivial, and only the
+	notable changes are logged.
+	
+	* automake.mk (src_data_libdata_a_SOURCES): Add the new source
+	files.
+	
+	* case.c (case_data): Renamed case_data_idx.
+	(case_num): Renamed case_num_idx.
+	(case_str): Renamed case_str_idx.
+	(case_data_rw): Renamed case_data_rw_idx.
+
+	* case.h (case_data): New function with old name and an interface
+	that takes a variable instead of an index, which is easier to
+	use.  Updated all callers to use the new interface, or to use the
+	new *_idx function (see above).
+	(case_num): Ditto.
+	(case_str): Ditto.
+	(case_data_rw): Ditto.
+	
+	* category.c (cat_stored_values_destroy): Changed interface to
+	take a struct cat_vals * instead of a struct variable *.
+
+	* dictionary.c (dict_clone): Use new vector_clone function.	
+	(dict_clear) Use new var_destroy function.
+	(add_var) New function.
+	(dict_create_var) Rewrite in terms of dict_create_var_assert.
+	(dict_create_var_assert) Rewrite in terms of add_var.
+	(dict_clone_var) Rewrite in terms of dict_clone_var_assert.
+	(dict_clone_var_assert) Rewrite in terms of var_clone, add_var.
+	(dict_lookup_var) Use new var_create, var_destroy functions.
+	(dict_contains_var) Rewrite in terms of new vardict functionality.
+	(set_var_dict_index) New function.
+	(set_var_case_index) New function.
+	(reindex_vars) New function.
+	(dict_delete_var) Rewrite in terms of new vardict functionality.
+	(dict_reorder_var) Ditto.
+	(dict_reorder_vars) Ditto.
+	(rename_var) New function.
+	(dict_rename_var) Use rename_var.
+	(dict_rename_vars) Use pool to simplify code.  Use rename_var.
+	(dict_get_compacted_idx_to_fv) Rename
+	dict_get_compacted_dict_index_to_case_index, update callers.
+	(dict_create_vector) Use new vector_create function.
+	(dict_clear_vectors) Use new vector_destroy function.
+	(set_var_short_name_suffix) Move here from variable.c, renamed
+	from var_set_short_name_suffix, make static, update caller.
+
+	* sys-file-private.c: New file.  
+	(sfm_width_to_bytes) Moved here from variable.c, renamed from
+	width_to_bytes, update callers.
+
+	* sys-file-private.h: New file.  Later it will supplant
+	sfm-private.h; for now it supplements it.
+	(macro MIN_VERY_LONG_STRING) New macro.
+	(macro EFFECTIVE_LONG_STRING_LENGTH) New macro, from value.h.
+
+	* sys-file-reader.c: Use MIN_VERY_LONG_STRING - 1 where
+	MAX_LONG_STRING was used before.
+
+	* sys-file-writer.c: Ditto.
+
+	* value-labels.c: Change the paradigm here to be that a null
+	pointer is OK for a struct val_labs * in most cases; it just
+	represents an empty set of value labels.
+	(val_labs_copy) A copy of a null set is a null set.
+	(val_labs_count) A null set has 0 labels.
+	(val_labs_replace) Change return type to void.  Rewrite for
+	simplicity.
+	(val_labs_find) A null set does not contain the value.
+	(value_to_string) Moved to variable.c, renamed var_get_value_name,
+	transposed argument order, updated all callers.
+
+	* value.c: New file.
+	(value_dup) Moved here from variable.c.
+	(compare_values) Ditto.
+	(hash_value) Ditto.
+
+	* value.h: (macro MAX_SHORT_STRING) Rewrote for simplicity.
+	(macro MAX_LONG_STRING) Removed, because it was only interesting
+	for system files, not for general code.
+	(macro MAX_VERY_LONG_STRING) Ditto.
+	(macro EFFECTIVE_LONG_STRING_LENGTH) Moved to sys-file-private.h.
+	(macro MAX_ELEMS_PER_VALUE) Removed, as it was unused.
+
+	* vardict.h: New file, for an interface between variables and
+	their dictionaries.
+
+	* variable.c: A lot of functions were moved around, for better
+	organization.
+	(struct variable) Move definition here, from variable.h.
+	(var_type_adj) Removed--makes i18n hard.
+	(var_type_noun) Ditto.
+	(var_create) New function.
+	(var_clone) New function.
+	(var_destroy) New function.
+	(var_set_name) Assert that variable is not in a dictionary.
+	(compare_var_names) Rename compare_vars_by_name and fix a couple
+	of callers who thought the args were strings.
+	(hash_var_name) Rename hash_var_by_name.
+	(compare_var_ptr_names) Rename compare_var_ptrs_by_name.
+	(hash_var_ptr_name) Rename hash_var_ptr_by_name.
+	(var_is_very_long_string) Removed, because it was only interesting
+	to system file code.
+	(var_set_missing_values) Allow the argument to be the wrong width,
+	as long as we can resize it.  Simplify callers who were doing the
+	resizing themselves.
+	(var_get_value_labels) New function.
+	(var_has_value_labels) New function.
+	(var_set_value_labels) New function.
+	(alloc_value_labels) New function.
+	(var_add_value_label) New function.
+	(var_replace_value_label) New function.
+	(var_clear_value_labels) New function.
+	(var_lookup_value_label) New function.
+	(var_get_value_name) Moved here from variable.c, renamed from
+	var_get_value_name, transposed argument order, updated all
+	callers.
+	(var_to_string) Moved here, from variable-label.c.
+	(var_set_leave) New function.
+	(var_get_leave) New function.
+	(var_must_leave) New function.
+	(var_set_short_name_suffix) Moved to dictionary.c, renamed
+	set_var_short_name_suffix.
+	(var_get_dict_index) New function.
+	(var_get_case_index) New function.
+	(var_get_obs_vals) New function.
+	(var_set_obs_vals) New function.
+	(var_has_obs_vals) New function.
+	(var_get_vardict) New function.
+	(var_set_vardict) New function.
+	(var_has_vardict) New function.
+	(var_clear_vardict) New function.
+	(value_dup) Moved to value.c.
+	(compare_values) Ditto.
+	(hash_value) Ditto.
+
+	* variable.h: (enum NUMERIC) Rename VAR_NUMERIC, update all users.
+	(enum ALPHA) Rename VAR_STRING, update all users.
+
+	* vector.c: New file.
+	(struct vector) Moved here, from variable.h.
+	(check_widths) New function.
+	(vector_create) New function.
+	(vector_clone) New function.
+	(vector_destroy) New function.
+	(vector_get_name) New function.
+	(vector_get_var) New function.
+	(vector_get_var_cnt) New function.
+	(compare_vector_ptrs_by_name) New function.
+
+	* vector.h: New file.
+
 Sun Dec 10 11:32:56 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* casefilter.c (casefilter_variable_missing): Avoided comparision of
@@ -23,10 +185,11 @@ Thu Dec  7 15:22:38 WST 2006 John Darrin
 
 Mon Dec  4 22:20:17 2006  Ben Pfaff  <blp@gnu.org>
 
-	Start converting struct variable to an opaque.  In this phase, we
-	add a bunch of setter and getter functions and convert most of the
-	PSPP code to use them.  The resulting changes are pervasive but
-	mostly trivial, and only the notable changes are logged.
+	Start converting struct variable to an opaque type.  In this
+	phase, we add a bunch of setter and getter functions and convert
+	most of the PSPP code to use them.  The resulting changes are
+	pervasive but mostly trivial, and only the notable changes are
+	logged.
 	
 	* format.c (fmt_equal): New function.
 	
Index: src/data/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/automake.mk,v
retrieving revision 1.9
diff -u -p -r1.9 automake.mk
--- src/data/automake.mk	29 Nov 2006 02:15:01 -0000	1.9
+++ src/data/automake.mk	10 Dec 2006 03:30:13 -0000
@@ -60,14 +60,19 @@ src_data_libdata_a_SOURCES = \
 	src/data/sfm-private.h \
 	src/data/storage-stream.c \
 	src/data/storage-stream.h \
+	src/data/sys-file-private.c \
+	src/data/sys-file-private.h \
 	src/data/sys-file-reader.c \
 	src/data/sys-file-reader.h \
 	src/data/sys-file-writer.c \
 	src/data/sys-file-writer.h \
 	src/data/transformations.c \
 	src/data/transformations.h \
+	src/data/value.c \
 	src/data/value.h \
 	src/data/value-labels.c \
 	src/data/value-labels.h \
 	src/data/variable.h \
-	src/data/variable.c 
+	src/data/variable.c \
+	src/data/vector.c \
+	src/data/vector.h
Index: src/data/case.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/case.c,v
retrieving revision 1.7
diff -u -p -r1.7 case.c
--- src/data/case.c	5 Dec 2006 15:10:21 -0000	1.7
+++ src/data/case.c	10 Dec 2006 03:30:13 -0000
@@ -255,7 +255,7 @@ case_from_values (struct ccase *c, const
    element of C numbered IDX.
    The caller must not modify the returned data. */
 const union value *
-case_data (const struct ccase *c, size_t idx) 
+case_data_idx (const struct ccase *c, size_t idx) 
 {
   assert (c != NULL);
   assert (c->case_data != NULL);
@@ -270,7 +270,7 @@ case_data (const struct ccase *c, size_t
 /* Returns the numeric value of the `union value' in C numbered
    IDX. */
 double
-case_num (const struct ccase *c, size_t idx) 
+case_num_idx (const struct ccase *c, size_t idx) 
 {
   assert (c != NULL);
   assert (c->case_data != NULL);
@@ -287,7 +287,7 @@ case_num (const struct ccase *c, size_t 
    (Note that the value is not null-terminated.)
    The caller must not modify the return value. */
 const char *
-case_str (const struct ccase *c, size_t idx) 
+case_str_idx (const struct ccase *c, size_t idx) 
 {
   assert (c != NULL);
   assert (c->case_data != NULL);
@@ -303,7 +303,7 @@ case_str (const struct ccase *c, size_t 
    element of C numbered IDX.
    The caller is allowed to modify the returned data. */
 union value *
-case_data_rw (struct ccase *c, size_t idx) 
+case_data_rw_idx (struct ccase *c, size_t idx) 
 {
   assert (c != NULL);
   assert (c->case_data != NULL);
@@ -342,16 +342,16 @@ case_compare_2dict (const struct ccase *
       
       if (var_get_width (va) == 0) 
         {
-          double af = case_num (ca, va->fv);
-          double bf = case_num (cb, vb->fv);
+          double af = case_num (ca, va);
+          double bf = case_num (cb, vb);
 
           if (af != bf) 
             return af > bf ? 1 : -1;
         }
       else 
         {
-          const char *as = case_str (ca, va->fv);
-          const char *bs = case_str (cb, vb->fv);
+          const char *as = case_str (ca, va);
+          const char *bs = case_str (cb, vb);
           int cmp = memcmp (as, bs, var_get_width (va));
 
           if (cmp != 0)
Index: src/data/case.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/case.h,v
retrieving revision 1.6
diff -u -p -r1.6 case.h
--- src/data/case.h	14 Oct 2006 00:25:20 -0000	1.6
+++ src/data/case.h	10 Dec 2006 03:30:13 -0000
@@ -23,6 +23,7 @@
 #include <stddef.h>
 #include <stdbool.h>
 #include "value.h"
+#include "variable.h"
 
 /* Opaque structure that represents a case.  Use accessor
    functions instead of accessing any members directly.  Use
@@ -68,11 +69,19 @@ CASE_INLINE void case_to_values (const s
 CASE_INLINE void case_from_values (struct ccase *,
                                    const union value *, size_t);
 
-CASE_INLINE const union value *case_data (const struct ccase *, size_t idx);
-CASE_INLINE double case_num (const struct ccase *, size_t idx);
-CASE_INLINE const char *case_str (const struct ccase *, size_t idx);
-
-CASE_INLINE union value *case_data_rw (struct ccase *, size_t idx);
+static inline const union value *case_data (const struct ccase *,
+                                            const struct variable *);
+static inline double case_num (const struct ccase *, const struct variable *);
+static inline const char *case_str (const struct ccase *,
+                                    const struct variable *);
+static inline union value *case_data_rw (struct ccase *,
+                                         const struct variable *);
+
+CASE_INLINE const union value *case_data_idx (const struct ccase *,
+                                              size_t idx);
+CASE_INLINE double case_num_idx (const struct ccase *, size_t idx);
+CASE_INLINE const char *case_str_idx (const struct ccase *, size_t idx);
+CASE_INLINE union value *case_data_rw_idx (struct ccase *, size_t idx);
 
 struct variable;
 int case_compare (const struct ccase *, const struct ccase *,
@@ -161,25 +170,25 @@ case_from_values (struct ccase *c, const
 }
 
 static inline const union value *
-case_data (const struct ccase *c, size_t idx) 
+case_data_idx (const struct ccase *c, size_t idx) 
 {
   return &c->case_data->values[idx];
 }
 
 static inline double
-case_num (const struct ccase *c, size_t idx) 
+case_num_idx (const struct ccase *c, size_t idx) 
 {
   return c->case_data->values[idx].f;
 }
 
 static inline const char *
-case_str (const struct ccase *c, size_t idx)
+case_str_idx (const struct ccase *c, size_t idx)
 {
   return c->case_data->values[idx].s;
 }
 
 static inline union value *
-case_data_rw (struct ccase *c, size_t idx)
+case_data_rw_idx (struct ccase *c, size_t idx)
 {
   if (c->case_data->ref_cnt > 1)
     case_unshare (c);
@@ -187,4 +196,44 @@ case_data_rw (struct ccase *c, size_t id
 }
 #endif /* !DEBUGGING */
 
+/* Returns a pointer to the `union value' used for the
+   element of C for variable V.
+   Case C must be drawn from V's dictionary.
+   The caller must not modify the returned data. */
+static inline const union value *
+case_data (const struct ccase *c, const struct variable *v)
+{
+  return case_data_idx (c, var_get_case_index (v));
+}
+
+/* Returns the numeric value of the `union value' in C for
+   variable V.
+   Case C must be drawn from V's dictionary. */
+static inline double
+case_num (const struct ccase *c, const struct variable *v) 
+{
+  return case_num_idx (c, var_get_case_index (v));
+}
+
+/* Returns the string value of the `union value' in C for
+   variable V.
+   Case C must be drawn from V's dictionary.
+   (Note that the value is not null-terminated.)
+   The caller must not modify the return value. */
+static inline const char *
+case_str (const struct ccase *c, const struct variable *v) 
+{
+  return case_str_idx (c, var_get_case_index (v));
+}
+
+/* Returns a pointer to the `union value' used for the
+   element of C for variable V.
+   Case C must be drawn from V's dictionary.   
+   The caller is allowed to modify the returned data. */
+static inline union value *
+case_data_rw (struct ccase *c, const struct variable *v) 
+{
+  return case_data_rw_idx (c, var_get_case_index (v));
+}
+
 #endif /* case.h */
Index: src/data/casefilter.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/casefilter.c,v
retrieving revision 1.3
diff -u -p -r1.3 casefilter.c
--- src/data/casefilter.c	10 Dec 2006 02:33:43 -0000	1.3
+++ src/data/casefilter.c	10 Dec 2006 03:30:13 -0000
@@ -58,9 +58,9 @@ casefilter_variable_missing (const struc
 			     const struct ccase *c,
 			     const struct variable *var)
 {
-  const union value *val = case_data (c, var->fv) ;
+  const union value *val = case_data (c, var) ;
 
-  if ( var_get_type (var) != ALPHA && val->f == SYSMIS )
+  if ( var_is_numeric (var) && val->f == SYSMIS )
     return true;
 
   if ( filter->exclude_user_missing &&
Index: src/data/cat-routines.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/cat-routines.h,v
retrieving revision 1.1
diff -u -p -r1.1 cat-routines.h
--- src/data/cat-routines.h	4 Mar 2006 01:11:57 -0000	1.1
+++ src/data/cat-routines.h	10 Dec 2006 03:30:13 -0000
@@ -49,5 +49,5 @@ void cat_value_update (struct variable *
 
 void cat_create_value_matrix (struct variable *);
 
-void cat_stored_values_destroy (struct variable *);
+void cat_stored_values_destroy (struct cat_vals *);
 #endif
Index: src/data/category.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/category.c,v
retrieving revision 1.5
diff -u -p -r1.5 category.c
--- src/data/category.c	5 Dec 2006 15:10:21 -0000	1.5
+++ src/data/category.c	10 Dec 2006 03:30:13 -0000
@@ -42,6 +42,7 @@
 #include <libpspp/alloc.h>
 #include <libpspp/message.h>
 #include "cat-routines.h"
+#include "value.h"
 #include "variable.h"
 
 #define N_INITIAL_CATEGORIES 1
@@ -49,30 +50,24 @@
 void
 cat_stored_values_create (struct variable *v)
 {
-  if (v->obs_vals == NULL)
+  if (!var_has_obs_vals (v))
     {
-      v->obs_vals = xmalloc (sizeof (*v->obs_vals));
-      v->obs_vals->n_categories = 0;
-      v->obs_vals->n_allocated_categories = N_INITIAL_CATEGORIES;
-      v->obs_vals->vals =
-	xnmalloc (N_INITIAL_CATEGORIES, sizeof *v->obs_vals->vals);
+      struct cat_vals *obs_vals = xmalloc (sizeof *obs_vals);
+      obs_vals->n_categories = 0;
+      obs_vals->n_allocated_categories = N_INITIAL_CATEGORIES;
+      obs_vals->vals = xnmalloc (N_INITIAL_CATEGORIES, sizeof *obs_vals->vals);
+      var_set_obs_vals (v, obs_vals);
     }
 }
 
 void
-cat_stored_values_destroy (struct variable *v)
+cat_stored_values_destroy (struct cat_vals *obs_vals)
 {
-  assert (v != NULL);
-
-  if (v->obs_vals != NULL)
+  if (obs_vals != NULL) 
     {
-      if (v->obs_vals->n_allocated_categories > 0)
-	{
-	  free (v->obs_vals->vals);
-	  v->obs_vals->vals = NULL;
-	}
-      free (v->obs_vals);
-      v->obs_vals = NULL;
+      if (obs_vals->n_allocated_categories > 0)
+        free (obs_vals->vals);
+      free (obs_vals);
     }
 }
 
@@ -82,15 +77,13 @@ cat_stored_values_destroy (struct variab
 size_t
 cat_value_find (const struct variable *v, const union value *val)
 {
+  struct cat_vals *obs_vals = var_get_obs_vals (v);
   size_t i;
   const union value *candidate;
 
-  assert (val != NULL);
-  assert (v != NULL);
-  assert (v->obs_vals != NULL);
-  for (i = 0; i < v->obs_vals->n_categories; i++)
+  for (i = 0; i < obs_vals->n_categories; i++)
     {
-      candidate = v->obs_vals->vals + i;
+      candidate = obs_vals->vals + i;
       assert (candidate != NULL);
       if (!compare_values (candidate, val, var_get_width (v)))
 	{
@@ -106,13 +99,9 @@ cat_value_find (const struct variable *v
 void
 cat_value_update (struct variable *v, const union value *val)
 {
-  struct cat_vals *cv;
-
   if (var_is_alpha (v))
     {
-      assert (val != NULL);
-      assert (v != NULL);
-      cv = v->obs_vals;
+      struct cat_vals *cv = var_get_obs_vals (v);
       if (cat_value_find (v, val) == CAT_VALUE_NOT_FOUND)
 	{
 	  if (cv->n_categories >= cv->n_allocated_categories)
@@ -131,15 +120,8 @@ cat_value_update (struct variable *v, co
 union value *
 cat_subscript_to_value (const size_t s, struct variable *v)
 {
-  assert (v->obs_vals != NULL);
-  if (s < v->obs_vals->n_categories)
-    {
-      return (v->obs_vals->vals + s);
-    }
-  else
-    {
-      return NULL;
-    }
+  struct cat_vals *obs_vals = var_get_obs_vals (v);
+  return s < obs_vals->n_categories ? obs_vals->vals + s : NULL;
 }
 
 /*
@@ -148,6 +130,6 @@ cat_subscript_to_value (const size_t s, 
 size_t 
 cat_get_n_categories (const struct variable *v)
 {
-  return v->obs_vals->n_categories;
+  return var_get_obs_vals (v)->n_categories;
 }
 
Index: src/data/data-in.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/data-in.c,v
retrieving revision 1.17
diff -u -p -r1.17 data-in.c
--- src/data/data-in.c	22 Nov 2006 04:24:02 -0000	1.17
+++ src/data/data-in.c	10 Dec 2006 03:30:14 -0000
@@ -34,7 +34,7 @@
 #include "calendar.h"
 #include "identifier.h"
 #include "settings.h"
-#include "variable.h"
+#include "value.h"
 
 #include <libpspp/assertion.h>
 #include <libpspp/compiler.h>
Index: src/data/data-out.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/data-out.c,v
retrieving revision 1.13
diff -u -p -r1.13 data-out.c
--- src/data/data-out.c	8 Dec 2006 01:41:21 -0000	1.13
+++ src/data/data-out.c	10 Dec 2006 03:30:15 -0000
@@ -32,7 +32,7 @@
 #include "calendar.h"
 #include "format.h"
 #include "settings.h"
-#include "variable.h"
+#include "value.h"
 
 #include <libpspp/assertion.h>
 #include <libpspp/float-format.h>
@@ -709,8 +709,8 @@ output_scientific (double number, const 
     p = mempset (p, ' ', ss_length (style->neg_suffix));
 
   assert (p == buf + format->w);
+  memcpy (output, buf, format->w);
 
-  buf_copy_str_lpad (output, format->w, buf);
   return true;
 }
 
